/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.datastore;

import com.ibm.eismocker.main.EisMockerConstaints;
import com.ibm.eismocker.utils.XSDScanner;

import commonj.sdo.DataObject;
import commonj.sdo.helper.CopyHelper;
import commonj.sdo.helper.DataFactory;

public class RequestDataItem extends DataItem {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private DataObject sdoResponse = null;
	private boolean isReplied = false;
	
	public RequestDataItem(DataObject sdo, String op) {
		super(sdo, op);
	}
	
	public void setResponseSDO(DataObject sdo){
		this.sdoResponse = sdo;
	}
	public DataObject getResponseSDO(){
		if(sdoResponse==null){
			createResponseSDO();
		}
		return this.sdoResponse;
	}
	public boolean getIsReplied(){
		return this.isReplied;
	}
	public void setIsReplied(boolean bl){
		this.isReplied = bl;
	}
	
	private void createResponseSDO(){
		if(EisMockerConstaints.OP_RETRIEVEALL.equalsIgnoreCase(this.getOperation())){//RetrieveAll op
			//reserved
			String boName = this.getDataObject().getType().getName();
			String containerName = boName +"Container";
			String nameSpace = XSDScanner.getNameSpaceByName(containerName);
			if(nameSpace!=null){
				sdoResponse = DataFactory.INSTANCE.create(nameSpace, containerName);
			}else{
				//no corresponding xsd found in the workspace.
			}
		}else if(EisMockerConstaints.OP_EXISTS.equalsIgnoreCase(this.getOperation())){//Exists op
			//reserved
		}else{//For other operations, the response BO type is the same with the input BO type.
			sdoResponse = CopyHelper.INSTANCE.copy(this.getDataObject());			
		}
	}

	@Override
	public String toString() {
		String strRt = super.toString();
		if(this.getIsReplied()){
			strRt = strRt + "<Replied>";	
		}else{
			strRt = strRt + "<New>";
		}
		return strRt;
	}
	
	

}
