/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.main;

public abstract class EisMockerConstaints {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}
	public final static int ACTION_NEW = 1;
	public final static int ACTION_SAVE = 2;
	public final static int ACTION_LOAD = 3;
	public final static int ACTION_EXIT = 4;
	public final static int ACTION_REMOVE =5;
	public final static int ACTION_CLEAR = 6;
	public final static int ACTION_SEND = 7;
	public final static int ACTION_BATCH_SEND = 8;
	public final static int ACTION_REPLY = 9;	
	public final static int ACTION_ABOUT = 10;	
	
	public final static int BATCH_ACTION_SEND = 11;	
	public final static int BATCH_ACTION_CANCEL = 12;	

	public final static int SEND_LIST = 20;
	public final static int RECEIVE_LIST = 21;

	public final static int REPLY_AUTO = 30;
	public final static int REPLY_MANU = 31;

	public final static String OP_RETRIEVEALL = "RetrieveAll";
	public final static String OP_RETRIEVE = "Retrieve";
	public final static String OP_EXISTS = "Exists";
	public final static String OP_CREATE = "Create";
	public final static String OP_UPDATE = "Update";
	public final static String OP_DELETE = "Delete";
	public final static String[] SUPPORTED_OPS = {OP_CREATE,OP_UPDATE,OP_DELETE};

	public final static String BOOLEAN = "Boolean";
	
	public static final String[] SUPPORT_DATA_TYPES = { "String", "Int", "Short", "Long", "Integer" };
	
	public static final String SUPPORT_RULE_NONE = "None";
	public static final String SUPPORT_RULE_INC = "Increase";
	public static final String SUPPORT_RULE_DEC = "Decrease";
	public static final String SUPPORT_RULE_SIZE = "Size";
	public static final String[] SUPPORT_VALUE_RULES = { SUPPORT_RULE_NONE,SUPPORT_RULE_INC,SUPPORT_RULE_DEC,SUPPORT_RULE_SIZE };

	public final static int INDEX_RULE_NONE = 0;	
	public final static int INDEX_RULE_INC = 1;	
	public final static int INDEX_RULE_DEC = 2;	
	public final static int INDEX_RULE_SIZE = 3;	
	
	
	public static final String NAME ="Name";
	public static final String RULE ="Rule";
	public static final String VALUE ="Value";
	
	public static final String DATEFORMAT_DATE ="yyyy-MM-dd";
	public static final String DATEFORMAT_DATETIME ="yyyy-MM-dd'T'HH:mm:ss.SSS";

	//For file menu
	public static final String MENU_FILE ="&File";
	public static final String MENU_FILE_LOAD ="&Load Business Object";
	public static final String MENU_FILE_SAVE ="&Save Business Object";
	public static final String MENU_FILE_EXIT ="&Exit";
	
	public static final String MENU_EDIT ="&Edit";
	public static final String MENU_EDIT_CREATE ="&Create Business Object";
	public static final String MENU_EDIT_DELETE ="&Delete Business Object";
	public static final String MENU_EDIT_CLEAR ="&Clear Business Object";

	public static final String MENU_REQUEST ="&Request";
	public static final String MENU_REQUEST_SEND ="&Send Request";
	public static final String MENU_REQUEST_SEND_BATCH ="Send &Batch Request";
	public static final String MENU_REQUEST_REPLY_SUCCESS ="&Reply Request With Success";
	public static final String MENU_REQUEST_REPLY_FAIL ="Reply Request With &Failure";
	public static final String MENU_REQUEST_REPLY_MODE ="Reply Request &Mode";
	public static final String MENU_MODE_AUTOMATIC ="&Automatic";
	public static final String MENU_MODE_MANUAL ="&Manual";

	public static final String MENU_HELP ="&Help";
	public static final String MENU_HELP_ABOUT ="&About";
	
	//Text on the editor
	public static final String BO_TYPE ="Business Object Type";
	public static final String OP_TYPE ="Operation Type";
	
	//Send and Receive Tabs.
	public final static String SEND_TAB = "Send";
	public final static String RECEIVE_TAB = "Receive";
	public static final String SEND_TAB_TIPS ="The requests that EIS Mocker has sent out";
	public static final String RECEIVE_TAB_TIPS ="The requests that EIS Mocker has received";
	
	
}
