/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.rmidriver;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Set;

public class DataMap implements Serializable{
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}
	
	private String name;
	
	private static final long serialVersionUID = 8563468015031264548L;
	
	private HashMap<String, Object> rootMap;	
	
	/**
	 * Constructor for Top Level DataMap which includes a field to record
	 * name for root DataObject construction. 
	 * @param name
	 */
	public DataMap(String name){
		this.name = name;
		rootMap = new HashMap<String, Object>();
	}	
	
	private DataMap(){
		rootMap = new HashMap<String, Object>();
	}
	
	public Object get(String key){
		return rootMap.get(key);
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@SuppressWarnings("unchecked")
	public List<DataMap> getList(String key){
		return (List)get(key);
	}
	
	public DataMap getDataMap(String key){
		return (DataMap)get(key);
	}
	
	public void set(String key, Object value){
		rootMap.put(key, value);
	}
	
	public Set<String> keySet(){
		return rootMap.keySet();
	}
	
	@SuppressWarnings("unchecked")
	public DataMap createDataMap(String key, boolean isMany){
		DataMap childMap = new DataMap();
		if(isMany){
			List<DataMap> list;
			if(rootMap.containsKey(key)){	
				list = (List) rootMap.get(key);
			}else{
				list = new ArrayList<DataMap>();
				rootMap.put(key, list);
			}
			list.add(childMap);			
		}else{
			rootMap.put(key, childMap);
		}
		return childMap;
	}
}
