/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.rmidriver;

import java.io.Serializable;
import java.sql.Timestamp;

public class EisEvent implements Serializable{
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private static final long serialVersionUID = 709394;
	
	private String eventId = null;
	private String eventType = null; // BO Type Name
	private int status;
	private String operation = null;
	private Timestamp buildTime;
	private String xid;

	public EisEvent(String eventId, String typeName, String operation) {
		this.eventId = eventId;
		this.eventType = typeName;
		this.operation = operation;
		buildTime = new Timestamp(System.currentTimeMillis());
		status = 0;
		xid = "";
	}

	public boolean equals(Object obj) {
		if(this == obj){
			return true;
		}
		if (!(obj instanceof EisEvent)) {
			return false;
		}
		EisEvent metaData = (EisEvent) obj;
		return (eventId == null ? metaData.eventId == null : eventId.equals(metaData.eventId))
				&& (eventType == null ? metaData.eventType == null: eventType.equals(metaData.eventType))
				&& (status == metaData.status)
				&& (operation == null ? metaData.operation == null : operation.equals(metaData.operation))
				&& (buildTime == null ? metaData.buildTime == null : buildTime.equals(metaData.buildTime))
				&& (xid == null ? metaData.xid == null : xid.equals(metaData.xid));
	}

	public int getStatus() {
		return status;
	}

	public void setStatus(int status) {
		this.status = status;
	}

	public String getOperation() {
		return operation;
	}

	public void setOperation(String operation) {
		this.operation = operation;
	}

	public String getEventId() {
		return eventId;
	}

	public String getEventType() {
		return eventType;
	}

	public Timestamp getBuildTime() {
		return buildTime;
	}

	public String getXid() {
		return xid;
	}

	public String toString() {
		return "VAEvent [" + eventId + ", " + eventType + ", "
				+ status + ", " + operation + ", " + buildTime + ", "
				+ xid + "]";
	}

}
