/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.rmidriver;

import java.rmi.Naming;
import java.rmi.RemoteException;

public class RMIObjectClient {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private String ip = null;

	private int port = -1;

	private String rmiPath = null;
	IDataObjectStore dOStore = null;

	public RMIObjectClient(String ip, int port) throws RemoteException{
		this.ip = ip;
		this.port = port;
		try {
			rmiPath = "rmi://" + this.ip + ":" + this.port + "/DOStoreService";
			dOStore = (IDataObjectStore) Naming.lookup(rmiPath);
		} catch (Exception e) {
			//CR91874 - remvoe EisMockerUtils reference
			//EisMockerUtils.getLogger().log(Level.SEVERE, e.getMessage(), e);
			throw new RemoteException(e.getMessage(), e);
		}
	}

	public IDataObjectStore getDataObjectStore() throws RemoteException {
		if(dOStore == null){
			throw new RemoteException("The connection is invalid!");
		}
		return dOStore;
	}
}
