/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.rmiserver;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.util.logging.Level;

import com.ibm.eismocker.rmidriver.IDataObjectStore;
import com.ibm.eismocker.utils.EisMockerUtils;

public class RMIObjectServer {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}
	
	private IDataObjectStore dOStore = null; 
	
	private String rmi_path = null;
	
	public RMIObjectServer(String rmiPath) throws RemoteException{
		//TODO: read the properties file. Implement later.
		this.rmi_path = rmiPath; 
		dOStore = new DataObjectStoreImpl();
	}
	
	public boolean start(){
		boolean blRt = true;
		try{
			Naming.rebind(rmi_path, dOStore);
		}catch(Exception e){
			EisMockerUtils.getLogger().log(Level.SEVERE, e.getMessage(), e);
			blRt = false;
		}
		return blRt;
	}

	public IDataObjectStore getDataObjectStore() {
		return dOStore;
	}
	
}
