/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.sdoviewer;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import commonj.sdo.Property;

public class SDOTreeContainerItem extends SDOTreeItem{
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private ArrayList<SDOTreeItem> childList = null;
	
	public SDOTreeContainerItem(Object obj, Property property, SDOTreeItem parentItem) {
		super(obj, property, parentItem);
		childList = new ArrayList<SDOTreeItem>();
	}

	public boolean add(SDOTreeItem obj){
		obj.setParent(this);
		return childList.add(obj);
	}
	
	public void addAll(Collection<SDOTreeItem> c){
		for(Iterator<SDOTreeItem> i = c.iterator() ; i.hasNext() ;){
			SDOTreeItem treeItem = i.next();
			add(treeItem);			
		}
	}
	
	public int getIndex(SDOTreeItem obj){
		return childList.indexOf(obj);
	}
	
	public int getChildrenCounts(){
		return childList.size();
	}
	
	public Object[] getChildren(){
		return childList.toArray();
	}
	
	public boolean remove(SDOTreeItem obj){
		return childList.remove(obj);
	}
	
	public boolean isContainment() {
		return true;
	}

	public boolean isDataObjectNode() {	
		return super.isDataObjectNode();
	}

}
