/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.sdoviewer;

import java.util.HashMap;

public class SDOTreeXSDMapper {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private static final String[] keyList = { "Boolean", "Byte", "Bytes",
		"Character", "DataObject", "DateTime", "Date", "Day", "Decimal",
		"Double", "Duration", "Float", "Int", "Integer", "Long", "Month",
		"MonthDay", "Object", "Short", "String", "Strings", "Time", "Year",
		"YearMonth", "YearMonthDay", "URI" };

	private static final String[] valueList = { "boolean", "byte", "hexBinary",
		"string", "anyType", "dateTime", "dateTime", "gDay", "decimal",
		"double", "duration", "float", "int", "integer", "long", "gMonth",
		"gMonthDay", "anySimpleType", "short", "string", "string", "time",
		"gYear", "gYearMonth", "date", "anyURI" };

	private static HashMap<String, String> typeMap = new HashMap<String, String>();

	static {
		for (int i = 0; i < keyList.length; i++) {
			typeMap.put(keyList[i], valueList[i]);
		}
	}

/**
 * Get the corresponding XSD type by SDO Type.
 * @param sdoType
 * @return
 */
public static String getType(String sdoType) {
	return typeMap.get(sdoType);
}

public static boolean containsKey(String sdoType){
	return typeMap.containsKey(sdoType);
}	

}
