/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.ui;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.Viewer;

import com.ibm.eismocker.datastore.DataItem;
import com.ibm.eismocker.datastore.DataStore;
import com.ibm.eismocker.main.EisMockerConstaints;

public class BOListViewerProviders extends LabelProvider implements IStructuredContentProvider{
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private int listType;
	
	public BOListViewerProviders(int type){
		listType = type;
	}
	
	//for IStructuredContentProvider
	public Object[] getElements(Object obj) {
		if(listType == EisMockerConstaints.SEND_LIST){// is send list
			return ((DataStore) obj).getEventDataItems();
		}else{ // is recieved list
			return ((DataStore) obj).getRequestDataItems();
		}
	}

	public void inputChanged(Viewer arg0, Object arg1, Object arg2) {		
	}
	
	// for LabelProvider
	public String getText(Object element) {
		DataItem item = (DataItem)element;
		return item.toString();
	}

}
