/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.eismocker.ui.batch;

import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Image;

import com.ibm.eismocker.main.EisMockerConstaints;

import commonj.sdo.DataObject;
import commonj.sdo.Property;

public class BatchSendTreeLabelProvider implements ITableLabelProvider {
	static String copyright() {
		return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}


	public String getColumnText(Object obj, int colNum) {
		BTreeItem treeItem = (BTreeItem) obj;
		Property property = treeItem.getProperty();

		if (colNum == 0) {
			if (property == null) {
				DataObject dataObj = (DataObject) treeItem.getObject();
				return dataObj.getType().getName();
			}

			if (treeItem.getParent().isWrapper()) {
				BTreeItem wrapper = (BTreeItem) treeItem.getParent();
				return property.getName() + "[" + wrapper.getIndex(treeItem) + "]";
			}

			if (treeItem.isWrapper()) {
				return property.getName() + "[" + treeItem.getChildrenCounts() + "]";
			}
			return property.getName();
		} else if (colNum == 1) {
			// For non-attribute value
			if (treeItem.isWrapper() || treeItem.isDataObjectNode()) {
				return null;
			}
			// Boolean value don't have Rule.
			String typeName = property.getType().getName();
			if (typeName.equalsIgnoreCase(EisMockerConstaints.BOOLEAN)) {
				return null;
			}
			return treeItem.getRule();
		} else {
			// For non-attribute value
			if (treeItem.isWrapper() || treeItem.isDataObjectNode()) {
				return null;
			}
			return treeItem.getValue();
		}
	}

	public Image getColumnImage(Object arg0, int arg1) {
		return null;
	}

	public void addListener(ILabelProviderListener arg0) {
		// TODO Auto-generated method stub
		
	}

	public void dispose() {
		// TODO Auto-generated method stub
		
	}

	public boolean isLabelProperty(Object arg0, String arg1) {
		// TODO Auto-generated method stub
		return false;
	}

	public void removeListener(ILabelProviderListener arg0) {
		// TODO Auto-generated method stub
		
	}

}
