/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.ui.batch;

import com.ibm.eismocker.utils.EisMockerUtils;



public class BatchValueChecker {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}
	public static final BatchValueChecker INSTANCE = new BatchValueChecker();
	private String sampleStr;
	private int length;
	
	private BatchValueChecker(){
		sampleStr = StringMaker.getSAMPLESTRING();
		length = sampleStr.length();
	}
	
	public boolean check(String str){
		if(str != null){
			if(str.length() < length){
				//For ordinary short value. Doesn't need to check.
				return false;
			}
			String subStr;
			if(str.length() > length*2 ){
				subStr = str.substring(0, length * 2);
			}else{
				subStr = str;
			}
			if(subStr.contains(sampleStr)){
				return true;
			}
		}
		return false;
	}
}

class StringMaker{
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}
	private static final String SAMPLESTRING = "AAAAABBBBBCCCCCDDDDD";
	private static final int SAMPLE_STR_BLENGTH = SAMPLESTRING.length() * 2;	//Size = string length * 2
	
	private static String value;
	private static int capacity = 0;
	private static int index = 0;
	
	/**Return String in <code>size</code> bytes.
	 * @param size
	 * @return
	 */
	public static String buildString(int size){
		int remain = capacity - index * 2 - size;
		if(remain < 0){		
			StringBuilder builder = new StringBuilder();
			int times = size/SAMPLE_STR_BLENGTH + 1;
			if(value != null){
				builder.append(value);
			}
			for (int i = 0; i < times; i++) {
				builder.append(SAMPLESTRING);
			}
			value = builder.toString();
			capacity = value.length() * 2;
			EisMockerUtils.getLogger().finest("Increase Capacity. Current = " + value.length());
		}
		int end = index + size/2;
		EisMockerUtils.getLogger().finest("Return String index from" + index + " to " + end + ".");
		String returnStr = value.substring(index, end);
		index = end;
		return returnStr;
	}
	
	public static void reset(){
		index = 0;
	}
	
	public static String getSAMPLESTRING() {
		return SAMPLESTRING;
	}
}
