/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.ui.responsebo;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

import com.ibm.eismocker.datastore.DataStore;
import com.ibm.eismocker.datastore.RequestDataItem;
import com.ibm.eismocker.sdoviewer.SDOTreeViewer;
import com.ibm.eismocker.utils.EisMockerUtils;
import com.ibm.eismocker.utils.ImageManager;

public class ResponseBOShell {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}
	private Shell shell = null;
	private RequestDataItem dataItem;
	
	public ResponseBOShell(Shell parent, RequestDataItem item){
		EisMockerUtils.getLogger().entering("ResponseBOShell", "ResponseBOShell");
		this.dataItem = item;
		this.shell = new Shell(parent,SWT.SHELL_TRIM |SWT.ON_TOP |SWT.APPLICATION_MODAL);
		shell.setImage(ImageManager.get("MainIcon"));
		shell.setText("Response BO Editor");
		shell.setSize(450, 400);
		shell.setLayout(new GridLayout());
		shell.setLocation(parent.getLocation().x+100,parent.getLocation().y+30);

		//sdoViewer
		SDOTreeViewer sdoViewer = new SDOTreeViewer(shell);
		sdoViewer.setContentSDO(dataItem.getResponseSDO());
		
		//add two buttons;
		Composite bottomComposite = new Composite(shell, SWT.FILL);
		GridLayout cLayout = new GridLayout(4, false);
		bottomComposite.setLayout(cLayout);
		
		Button replyButton = new Button(bottomComposite, SWT.NONE);
		replyButton.setText("&Reply");
		replyButton.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
			public void widgetSelected(SelectionEvent arg0) {
				sendResponseBO();
				shell.dispose();
			}
		});
		
		Button cancellButton = new Button(bottomComposite, SWT.NONE);
		cancellButton.setText("&Cancell");
		cancellButton.addSelectionListener(new SelectionListener() {

			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
			public void widgetSelected(SelectionEvent arg0) {
				shell.dispose();
			}
		});
		EisMockerUtils.getLogger().exiting("ResponseBOShell", "ResponseBOShell");
	}
	public void sendResponseBO(){
		synchronized (this.dataItem) {
			this.dataItem.setIsReplied(true);
			DataStore.getDataStore().fireReceivedListChanged();
			this.dataItem.notify();
		}
	}
	public void open() {
		shell.open();
		shell.layout();
	}

}
