/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.utils;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

public class ImageManager {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}
	private static ImageManager imageManager=null;
	private ImageRegistry imageRegistry=null;


	public static Image get(String key) {
		if(imageManager==null){
			imageManager = new ImageManager();
			imageManager.initImages();
		}
		return imageManager.imageRegistry.get(key);
	}
	public void initImages(){
		imageRegistry = new ImageRegistry();
		Image image =null;
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/mainIcon.gif").createImage();
		imageRegistry.put("MainIcon", image);
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/newBO.gif").createImage();
		imageRegistry.put("New", image);
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/loadBO.gif").createImage();
		imageRegistry.put("Load", image);
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/saveBO.gif").createImage();
		imageRegistry.put("Save", image);
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/sendBO.gif").createImage();
		imageRegistry.put("Send", image);
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/sendBOBatch.gif").createImage();
		imageRegistry.put("BatchSend", image);
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/clearBO.gif").createImage();
		imageRegistry.put("Clear", image);
		image = ImageDescriptor.createFromFile(this.getClass(), "icons/removeBO.gif").createImage();
		imageRegistry.put("Remove", image);
	}

	@Override
	protected void finalize() throws Throwable {
		super.finalize();
		imageRegistry.dispose();
	}
}
