/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.eismocker.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Level;

import commonj.sdo.helper.XSDHelper;

/**
 * A helper class use to search *.xsd file for the GUI initialization. Note: Can
 * be replaced by XSDHelper in SDO 2.0.
 * 
 */
public class XSDScanner {
	static String copyright() {
		 return com.ibm.eismocker.rmidriver.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private static HashMap<String, String> nameSpaceMap = new HashMap<String, String>();

	public static String[] initializeSupportedBOList(String workspaceDir) throws Exception {

		ArrayList<String> boArray = new ArrayList<String>();
		File curDir = new File(workspaceDir);
		File[] files = curDir.listFiles();
		for (int i = 0; i < files.length; i++) {
			if (files[i].isFile() && files[i].getName().endsWith(".xsd")) {
				// load the file for SDO2 Lib.
				File xsdFile = files[i];
				FileInputStream fis = new FileInputStream(xsdFile);
				XSDHelper.INSTANCE.define(fis, null);
				fis.close();
				// save the BO name and related namespace
				String fileName = xsdFile.getName();
				String boName = fileName.substring(0, fileName.indexOf(".xsd"));
				if (!boArray.contains(boName)) {
					boArray.add(boName);
					String nameSpace = getNameSpaceStrFromFile(files[i]);
					nameSpaceMap.put(boName, nameSpace);
				}
			}
		}
		String[] arrayBOs = new String[boArray.size()];
		boArray.toArray(arrayBOs);
		return arrayBOs;
	}

	private static String getNameSpaceStrFromFile(File file){
		try {
			BufferedReader reader = new BufferedReader(new FileReader(file));
			String line = reader.readLine();
			while (line != null) {
				int startIdx = line.indexOf("targetNamespace");
				if (startIdx > -1) {
					int idx = line.indexOf('"', startIdx + 1);
					int lastIdx = line.indexOf('"', idx + 1);
					String nameSpace = line.substring(idx + 1, lastIdx);
					return nameSpace;
				}
				line = reader.readLine();
			}
		} catch (FileNotFoundException e) {
			EisMockerUtils.getLogger().log(Level.SEVERE, e.getMessage(), e);
		} catch (IOException e) {
			EisMockerUtils.getLogger().log(Level.SEVERE, e.getMessage(), e);
		}

		return "";
	}

	public static String getNameSpaceByName(String typeName) {
		return (String) nameSpaceMap.get(typeName);
	}
}
