/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.vta;

import java.util.logging.Level;

import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.spi.ResourceAdapter;
import javax.security.auth.Subject;

import com.ibm.j2ca.base.WBIConnectionRequestInfo;
import com.ibm.j2ca.base.WBIManagedConnection;
import com.ibm.j2ca.base.WBIManagedConnectionFactory;
import com.ibm.j2ca.base.WBIResourceAdapterMetadata;

public class VTAManagedConnectionFactory extends WBIManagedConnectionFactory {
	static String copyright() {
		 return com.ibm.j2ca.vta.common.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private static final long serialVersionUID = 6051743059667354552L;
	
	private String hostname = null;
	private String portnumber = null; 
	final String CLASS_NAME = "VTAManagedConnectionFactory";
	final String METHOD_NAME = "getResourceAdapterMetadata";
	
	public Object createConnectionFactory(ConnectionManager cm)
			throws ResourceException {
		return new VTAConnectionFactory(cm, this);	
	}

	public ManagedConnection createManagedConnection(Subject subject,
			ConnectionRequestInfo connRequestInfo) throws ResourceException {
        VTAManagedConnection conn = new VTAManagedConnection(this, subject, (WBIConnectionRequestInfo)connRequestInfo);
        return conn;
	}

	public String getHostname(){
		return this.hostname;
	}
	public void setHostname(String host){
		this.hostname = host;
	}
	public String getPortnumber(){
		return this.portnumber;
	}
	public void setPortnumber(String port){
		this.portnumber = port;
	}
	public void setResourceAdapter(ResourceAdapter resourceAdapter)throws ResourceException {
		super.setResourceAdapter(resourceAdapter);
	}
	//CR92003
	public WBIResourceAdapterMetadata getResourceAdapterMetadata() {
		try {
			return new VTAResourceAdapterMetaData();
		}
		catch (ResourceException e) {
			this.getLogUtils().log(Level.SEVERE, CLASS_NAME, METHOD_NAME, "Exception occured while initializing WBIResourceAdapterMetadata. Message: " + e.getMessage());//$NON-NLS-1$
		}
		return null;	
	}
	/**
	 * This method is to validate connection to EIS. The user needs to implement this method. 
	 */
	public boolean validateManagedConnection(WBIManagedConnection mngConn){
		//TODO
		return true;
	}
}
