/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.vta;

import java.util.logging.Level;

import javax.resource.ResourceException;
import javax.resource.spi.BootstrapContext;
import javax.resource.spi.CommException;
import javax.resource.spi.ResourceAdapterInternalException;

import com.ibm.j2ca.base.WBIActivationSpecWithXid;
import com.ibm.j2ca.base.WBIPollableResourceAdapterWithXid;
import com.ibm.j2ca.base.WBIResourceAdapter;
import com.ibm.j2ca.base.WBIResourceAdapterMetadata;
import com.ibm.j2ca.extension.eventmanagement.EventStoreWithXid;
import com.ibm.j2ca.extension.logging.LogUtils;

public class VTAResourceAdapter extends WBIResourceAdapter implements WBIPollableResourceAdapterWithXid {
	static String copyright() {
		return com.ibm.j2ca.vta.common.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private WBIResourceAdapterMetadata raMetaData = null;

	public void start(BootstrapContext btStrpCtxt)
			throws ResourceAdapterInternalException {
		super.start(btStrpCtxt);
	}

	public WBIResourceAdapterMetadata getResourceAdapterMetadata()
			throws ResourceException {
		if (raMetaData == null) {
			//CR92003
			raMetaData = new WBIResourceAdapterMetadata(
					"WebSphere Sample Adapter for Enterprise Information System Simulator", "IBM", "7.0.0.0",
					true, "VTARA");
		}
		return raMetaData;
	}

	public EventStoreWithXid createEventStore(WBIActivationSpecWithXid actSpec)
			throws ResourceException {
		LogUtils logUtils = this.getLogUtils();
		if (logUtils.isTraceEnabled(Level.FINE))
			logUtils.traceMethodEntrance(
					VTAAdapterConstants.VTARESOURCEADAPTER, "createEventStore");
		VTAEventStoreWithXid eventStore = null;
		try {
			eventStore = new VTAEventStoreWithXid(
					(VTAActivationSpecWithXid) actSpec, logUtils);
		} catch (Exception e) {
			// throw CommException, for AFC CR 69609 Support connection retry at
			// adapter startup
			throw new CommException(e.getMessage(), e);
		}

		if (logUtils.isTraceEnabled(Level.FINE))
			logUtils.traceMethodExit(VTAAdapterConstants.VTARESOURCEADAPTER,
					"createEventStore");
		return eventStore;
	}
}
