/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.vta;

import com.ibm.despi.OutputAccessor;
import com.ibm.despi.OutputCursor;
import com.ibm.despi.exception.DESPIException;
import com.ibm.eismocker.rmidriver.DataMap;
import com.ibm.j2ca.base.WBIInteractionSpec;
import com.ibm.j2ca.base.WBIStructuredRecord;
import com.ibm.j2ca.extension.metadata.Type;

public class VTAStructureRecord extends WBIStructuredRecord {
	static String copyright() {
		 return com.ibm.j2ca.vta.common.Copyright.IBM_COPYRIGHT_SHORT;
	}

	private static final long serialVersionUID = 5150851386271623504L;
	private String bgVerb="";
	private boolean isBG=false;

	public VTAStructureRecord(){
		super();
	}
	
	public void extract(String arg0) throws DESPIException {
	}

	public boolean getNext(boolean arg0) throws DESPIException {
		//For inbound processing.
		DataMap dataMap = (DataMap) this.getEISRepresentation();
		if(dataMap.getName().endsWith("BG")){// it is a BG, then get the root BO.
			String bgName = dataMap.getName();
			String bgVerb = (String)dataMap.get(VTAAdapterConstants.VERB);
			this.setBGVerb(bgVerb);
			String boName = bgName.substring(0, bgName.length()-2);
			dataMap = dataMap.getDataMap(boName);
		}
		Type metadata = this.getMetadata();
		OutputCursor topCursor = (OutputCursor)this.getTopLevelCursor();
		
		if(this.getOperationName().equalsIgnoreCase(WBIInteractionSpec.EXISTS_OP)){
			//Boolean value = new Boolean(true);
			Boolean value = (Boolean)this.getEISRepresentation();
			topCursor.startObject();
			OutputAccessor accessor = (OutputAccessor)topCursor.getAccessors().get(0);
			accessor.setBoolean(value.booleanValue());
			topCursor.completeObject();
			return true;			
		}
		if(this.getOperationName().equalsIgnoreCase(WBIInteractionSpec.RETRIEVE_ALL_OP)){
			//topCursor.startObject();
			//OutputAccessor accessor = (OutputAccessor)topCursor.getAccessors().get(0);
			//accessor.setBoolean(value.booleanValue());
			//topCursor.completeObject();	
			return false;
		}
		
		topCursor.startObject();
		VTAUtil.copyDataMapToRecord(dataMap, topCursor, metadata,this.getLogUtils());
		topCursor.completeObject();
		
		return true;
	}
	
	//CR91999 - process the BG case.
	public void setBGVerb(String verb){
		this.bgVerb = verb;
	}
	public String getBGVerb(){
		return this.bgVerb;
	}
	public void setIsBG(boolean bg){
		this.isBG = bg;
	}
	public boolean getIsBG(){
		return this.isBG;
	}
	//CR91999 End

}
