/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.vta.emd.discovery;

import com.ibm.j2ca.extension.emd.PropertyNameHelper;
import com.ibm.j2ca.extension.emd.discovery.WBIAdapterTypeImpl;
import com.ibm.j2ca.extension.emd.discovery.WBIMetadataEditImpl;
import com.ibm.j2ca.vta.emd.discovery.connection.VTAInboundConnectionType;
import com.ibm.j2ca.vta.emd.discovery.connection.VTAOutboundConnectionType;

import commonj.connector.metadata.MetadataConfigurationType;
import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.connection.InboundConnectionType;
import commonj.connector.metadata.discovery.connection.OutboundConnectionType;

public class VTAMetadataEdit extends WBIMetadataEditImpl {
	static String copyright() {
		 return com.ibm.j2ca.vta.common.Copyright.IBM_COPYRIGHT_SHORT;
	}

	WBIAdapterTypeImpl adapterType;
	PropertyNameHelper helper = null;
	
	public VTAMetadataEdit() throws MetadataException {
		
		helper = new PropertyNameHelper(null, "com.ibm.j2ca.vta.emd", null);
		
		adapterType = new WBIAdapterTypeImpl("com.ibm.j2ca.vta.VTAResourceAdapter", 2, 1);
		VTAOutboundConnectionType outConnTypeForMetadata = new VTAOutboundConnectionType(adapterType,helper);
		outConnTypeForMetadata.setIsSupportedInMetadataService(true);
		outConnTypeForMetadata.setManagedConnectionFactoryJavaBean("com.ibm.j2ca.vta.VTAManagedConnectionFactory");
		adapterType.addOutboundConnectionType(outConnTypeForMetadata);

		VTAOutboundConnectionType outConnTypeForRuntime = new VTAOutboundConnectionType(adapterType,helper);
		adapterType.addOutboundConnectionType(outConnTypeForRuntime);
		outConnTypeForRuntime.setManagedConnectionFactoryJavaBean("com.ibm.j2ca.vta.VTAManagedConnectionFactory");
		outConnTypeForRuntime.setResourceAdapterJavaBean("com.ibm.j2ca.vta.VTAResourceAdapter");
		outConnTypeForRuntime.setIsSupportedInMetadataService(false);

		VTAInboundConnectionType inConnTypeForRuntime = new VTAInboundConnectionType(adapterType,helper);
		adapterType.addInboundConnectionType(inConnTypeForRuntime);
		inConnTypeForRuntime.setResourceAdapterJavaBean("com.ibm.j2ca.vta.VTAResourceAdapter");
		inConnTypeForRuntime.setActivationSpecJavaBean("com.ibm.j2ca.vta.VTAActivationSpecWithXid");
	}
	
	
	public InboundConnectionType getInboundConnectionType(String arg0)
			throws MetadataException {
		return adapterType.getInboundConnectionTypes()[0];	
	}

	public OutboundConnectionType getOutboundConnectionType(String arg0)
			throws MetadataException {
		return adapterType.getOutboundConnectionTypes()[1];
	}


	public MetadataConfigurationType[] getSupportedConfiguration() {
		return VTAMetadataDiscovery.getMetadataConfiguration();
	}

}
