/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.vta.emd.discovery.connection;

import java.util.logging.Level;

import com.ibm.j2ca.extension.emd.PropertyNameHelper;
import com.ibm.j2ca.extension.emd.discovery.WBIAdapterTypeImpl;
import com.ibm.j2ca.extension.emd.discovery.connection.WBIInboundConnectionTypeImpl;
import com.ibm.j2ca.extension.logging.LogUtilConstants;
import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.connection.InboundConnectionConfiguration;

public class VTAInboundConnectionType extends WBIInboundConnectionTypeImpl {
	static String copyright() {
		 return com.ibm.j2ca.vta.common.Copyright.IBM_COPYRIGHT_SHORT;
	}

	VTAInboundConnectionConfiguration conf = null;
	PropertyNameHelper helper = null;

	public VTAInboundConnectionType(WBIAdapterTypeImpl adapterType,PropertyNameHelper helper) throws MetadataException {
		super(adapterType);
		this.helper = helper;
	}

	public InboundConnectionConfiguration createInboundConnectionConfiguration() {
		if ((helper.getLogUtils()!=null) && helper.getLogUtils().isTraceEnabled(Level.FINE))
			helper.getLogUtils().traceMethodEntrance("VTAInboundConnectionType", "createInboundConnectionConfiguration");
		
		try {
			if (conf == null)
				conf = new VTAInboundConnectionConfiguration(this,helper);
		} catch (Exception e) {
			//if ((helper.getLogUtils()!=null) && helper.getLogUtils().isTraceEnabled(Level.FINE))
				//helper.getLogUtils().log(Level.SEVERE, LogUtilConstants.ADAPTER_RBUNDLE, "VTAInboundConnectionType", "createInboundConnectionConfiguration", "1004", new Object[] { e.getMessage() }); //$NON-NLS-1$ 
			throw new RuntimeException(e.getMessage(), e);
		}

		if ((helper.getLogUtils()!=null) && helper.getLogUtils().isTraceEnabled(Level.FINE))
			helper.getLogUtils().traceMethodExit("VTAInboundConnectionType", "createInboundConnectionConfiguration");
		return conf;
	}

}
