/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.vta.emd.discovery.connection;

import java.util.logging.Level;

import com.ibm.j2ca.extension.emd.PropertyNameHelper;
import com.ibm.j2ca.extension.emd.discovery.WBIAdapterTypeImpl;
import com.ibm.j2ca.extension.emd.discovery.connection.WBIOutboundConnectionTypeImpl;
import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.connection.OutboundConnectionConfiguration;

public class VTAOutboundConnectionType extends WBIOutboundConnectionTypeImpl {
	static String copyright() {
		 return com.ibm.j2ca.vta.common.Copyright.IBM_COPYRIGHT_SHORT;
	}

	VTAOutboundConnectionConfiguration conf=null;
	PropertyNameHelper helper = null;
	
	public VTAOutboundConnectionType(WBIAdapterTypeImpl adapterType,PropertyNameHelper helper) throws MetadataException {
		super(adapterType, helper);
		this.helper = helper;
		setDescription("Connection to VTA system");
		setDisplayName("VTA Connection");
		setId("VTA");
	}

	public OutboundConnectionConfiguration createOutboundConnectionConfiguration() {
		//CR91877 - add checking for helper.getLogUtils()!=null
		if ((helper.getLogUtils()!=null) && helper.getLogUtils().isTraceEnabled(Level.FINE))
			helper.getLogUtils().traceMethodEntrance("VTAOutboundConnectionType", "createOutboundConnectionConfiguration");
		
		try {
			if (conf == null)
				conf = new VTAOutboundConnectionConfiguration(this,helper);
		} catch (Exception e) {
			throw new RuntimeException(e.getMessage(), e);
		}
		//CR91877 - add checking for helper.getLogUtils()!=null
		if ((helper.getLogUtils()!=null) && helper.getLogUtils().isTraceEnabled(Level.FINE))
			helper.getLogUtils().traceMethodExit("VTAOutboundConnectionType", "createOutboundConnectionConfiguration");
		return conf;
	}

}
