/*
 * IBM Confidential
 * OCO Source Materials
 * --------------
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.vta.emd.runtime;

import javax.resource.cci.Record;

import com.ibm.j2ca.base.WBIInteractionSpec;
import com.ibm.j2ca.base.internal.WPSServiceHelper;
import com.ibm.j2ca.extension.dataexchange.sdo.DEFactorySDO;
import com.ibm.j2ca.vta.VTAAdapterConstants;
import com.ibm.j2ca.vta.VTAStructureRecord;
import commonj.connector.runtime.DataBindingException;
import commonj.connector.runtime.RecordHolderDataBinding;
import commonj.sdo.DataObject;
import commonj.sdo.Property;

public abstract class VTADataBinding implements RecordHolderDataBinding {
	static String copyright() {
		 return com.ibm.j2ca.vta.common.Copyright.IBM_COPYRIGHT_SHORT;
	}

	VTAStructureRecord record = null;

	DataObject inputBG = null;

	public Record getRecord() throws DataBindingException {
		return record;
	}

	public void setRecord(Record arg0) throws DataBindingException {
		this.record = (VTAStructureRecord) arg0;	
	}

	public DataObject getDataObject() throws DataBindingException {
		DataObject returnValue = null;

		try {
			DEFactorySDO binding = new DEFactorySDO();
			DataObject dataObject = null;
			dataObject = WPSServiceHelper.createBusinessObject(this.getNamespaceURI(), this.getBusinessObjectName());
			//RetrieveAll, create a container SDO
			if (record.getOperationName().equalsIgnoreCase(WBIInteractionSpec.RETRIEVE_ALL_OP)) {
				DataObject returnObject = dataObject;
				Property p = (Property) returnObject.getType().getProperties().get(0);
				dataObject = WPSServiceHelper.createBusinessObject(p.getType().getURI(), p.getType().getName());
				boolean isBG = WPSServiceHelper.isBusinessGraph(returnObject);
				if (isBG)
					dataObject = dataObject.createDataObject(WPSServiceHelper.getRootBusinessObjectProperty(dataObject.getType()));
				Object[] array = new Object[1];
				array[0] = dataObject;
				record.initializeOutput(binding, array);
				while (record.getNext(true)) {
					DataObject object = (DataObject) binding.getBoundObject();
					if (dataObject.getContainer() != null) {
						DataObject BG = WPSServiceHelper.createDataObject(object.getType().getURI() + "bg", object.getType().getName() + "BG"); //$NON-NLS-1$ //$NON-NLS-2$
						BG.set(WPSServiceHelper.getRootBusinessObjectProperty(BG.getType()), object);
						//CR91880 - set "verb" for inbound/outbound operation.
						//CR91999
						//BG.set(VTAAdapterConstants.VERB, record.getOperationName());
						returnValue.set(VTAAdapterConstants.VERB, record.getBGVerb());
						returnObject.getList(0).add(BG);
					} else
						returnObject.getList(0).add(object);
				}
				return returnObject;
			}

			boolean isBG = WPSServiceHelper.isBusinessGraph(dataObject);
			if (isBG)
				dataObject = dataObject.createDataObject(WPSServiceHelper.getRootBusinessObjectProperty(dataObject.getType()));
			Object[] array = new Object[1];
			array[0] = dataObject;
			record.initializeOutput(binding, array);
			if (record.getOperationName().equalsIgnoreCase(WBIInteractionSpec.DELETE_OP)) {
				if(record.getNext(true)){
				DataObject object = (DataObject) binding.getBoundObject();
				DataObject bg = dataObject.getContainer();
				if (bg != null) {
					returnValue = WPSServiceHelper.createDataObject(bg.getType().getURI(), bg.getType().getName());
					returnValue.set(WPSServiceHelper.getRootBusinessObjectProperty(returnValue.getType()), object);
					//CR91880 - set "verb" for inbound/outbound operation.
					//CR91999
					//returnValue.set(VTAAdapterConstants.VERB, record.getOperationName());
					returnValue.set(VTAAdapterConstants.VERB, record.getBGVerb());
				} else{
					returnValue = object;
				}
				}
			} else if (record.getNext(true)) {
				DataObject object = (DataObject) binding.getBoundObject();
				DataObject bg = dataObject.getContainer();
				if (bg != null) {
					returnValue = WPSServiceHelper.createDataObject(bg.getType().getURI(), bg.getType().getName());
					returnValue.set(WPSServiceHelper.getRootBusinessObjectProperty(returnValue.getType()), object);
					//CR91880 - set "verb" for inbound/outbound operation.
					//CR91999
					//returnValue.set(VTAAdapterConstants.VERB, record.getOperationName());
					returnValue.set(VTAAdapterConstants.VERB, record.getBGVerb());
				} else{
					returnValue = object;
				}
			}
		} catch (Exception e) {
			throw new DataBindingException("Failed in population return object", e); //$NON-NLS-1$
		}
		return returnValue;
	}

	public void setDataObject(DataObject arg0) throws DataBindingException {
		try {
			record = new VTAStructureRecord();
			inputBG = arg0;
			DEFactorySDO binding = new DEFactorySDO();
			boolean isBG = WPSServiceHelper.isBusinessGraph(arg0);
			DataObject dataObject = null;
			if (isBG) {
				dataObject = WPSServiceHelper.getRootBusinessObjectInstance(arg0);
				String verb = arg0.getString(VTAAdapterConstants.VERB);
				if(verb != null){
					//CR91999 - process the BG case
					record.setOperationName(verb);
					record.setBGVerb(verb);
				}
				//CR91999
				record.setIsBG(true);
			} else
				dataObject = arg0;
			binding.setBoundObject(dataObject);
			Object[] array = new Object[1];
			array[0] = dataObject;
			record.initializeInput(binding, array);
			record.setNamespace(inputBG.getType().getURI());
			record.setRecordName(inputBG.getType().getName());
		} catch (Exception e) {
			throw new DataBindingException("Failed to initialize cursor", e); //$NON-NLS-1$ 
		}
	}
	public abstract String getNamespaceURI();

	public abstract String getBusinessObjectName();

}
